import * as multer from 'multer';
import { OpenAPIV3, ValidateRequestOpts, ValidateSecurityOpts, Format } from 'openapi-core';
export interface FastifyOpenApiValidatorOpts {
    apiSpec: OpenAPIV3.Document | string;
    validateRequests?: boolean | ValidateRequestOpts;
    validateSecurity?: boolean | ValidateSecurityOpts;
    ignorePaths?: RegExp | Function;
    coerceTypes?: boolean | 'array';
    unknownFormats?: true | string[] | 'ignore';
    formats?: Format[];
    fileUploader?: boolean | multer.Options;
    $refParser?: {
        mode: 'bundle' | 'dereference';
    };
    validateFormats?: false | 'fast' | 'full';
}
